<template>
  <div>
    <div style="position: relative; width: fit-content">
      <img
        v-if="src"
        :src="src"
        alt="Avatar"
        class="avatar image"
        :style="{ height: size, width: size }"
      />
      <div
        v-else
        class="avatar no-image"
        :style="{ height: size, width: size }"
      />
      <LoadsSpinner style="position: absolute; top: calc(50% - 10px); left: calc(50% - 10px)" v-if="uploading || loading" small/>
    </div>
    <div :style="{ width: size }">
      <label class="button primary block" for="single">
        <span v-if="!uploading && !loading">{{ src.length ? "Change" : "Upload" }}</span>
        <LoadsSpinner v-if="uploading || loading" small/>
      </label>
      <input
        style="visibility: hidden; position: absolute"
        type="file"
        id="single"
        accept="image/*"
        @change="uploadAvatar"
        :disabled="uploading"
      />
    </div>
  </div>
</template>

<script>
import { ref, toRefs, watch } from "vue"
import { supabase } from "../supabase"
import LoadsSpinner from "./Loads-spinner.vue";

export default {
  name: "Avatar",
  components: {LoadsSpinner},
  props: {
    path: String,
  },
  emits: ["upload", "update:path"],
  setup(prop, { emit }) {
    const { path } = toRefs(prop)
    const size = ref("10em")
    const uploading = ref(false)
    const src = ref("")
    const files = ref()
    const loading = ref(false)

    const downloadImage = async () => {
      try {
        loading.value = true
        const { data, error } = await supabase.storage
          .from("avatars")
          .download(path.value)
        if (error) throw error
        src.value = URL.createObjectURL(data)
      } catch (error) {
        console.error("Error downloading image: ", error.message)
      } finally {
        loading.value = false
      }
    }

    const uploadAvatar = async (evt) => {
      files.value = evt.target.files
      try {
        uploading.value = true
        if (!files.value || files.value.length === 0) {
          throw new Error("You must select an image to upload.")
        }

        const file = files.value[0]
        const fileExt = file.name.split(".").pop()
        const fileName = `${Math.random()}.${fileExt}`
        const filePath = `${fileName}`

        let { error: uploadError } = await supabase.storage
          .from("avatars")
          .upload(filePath, file)

        if (uploadError) throw uploadError
        emit("update:path", filePath)
        emit("upload")
      } catch (error) {
        alert(error.message)
      } finally {
        uploading.value = false
      }
    }

    watch(path, () => {
      if (path.value) downloadImage()
    })

    return {
      size,
      uploading,
      src,
      files,
      loading,

      uploadAvatar,
    }
  },
}
</script>
